# misc.itcl - Miscellaneous utility functions.
#
# FIXME: Move into ::tycho namespace
#

##########################################################################
#
# Author:  H. John Reekie & Jose Luis Pino
#
# Version: @(#)misc.tcl	1.14 12/16/96
#
# Copyright (c) 1990-1996 The Regents of the University of California.
# All rights reserved.
# 
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
# 
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
# 
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
##########################################################################

##########################################################################
#### abstractMethod
#
# Complain about an abstract method being called.
#
proc abstractMethod {method} {
    error "Method $method of class [uplevel {info context}] is abstract."
}

##########################################################################
##### background
#
# Execute a script in the background repeatedly. Useful mainly for
# testing: could be modified to terminate according to the script's
# return value.
#
proc background {cmd} {
    uplevel #0 $cmd
    after idle [list background $cmd]
}

##########################################################################
##### min 
# Return the smallest of two numbers. The load of this procedure checks
# that one doesn't already exist to prevent overwriting the ptklib
# version (which takes multiple arguments).
#
# Note: this version doesn't take multiple arguments: I would prefer
# that the multiple arg version be named say minimum{}, keeping this
# one the way it is for ``speed'' (it is used in some of the critical
# list-iterator functions).
#
# FIXME: Renamed min2 because of autoload problem.
#
proc min2 {x y} {
    if { $x < $y } {
	set x
    } else {
	set y
    }
}


# if { [info commands min] == "" } {
#     proc min {x y} {
# 	if { $x < $y } {
# 	    set x
# 	} else {
# 	    set y
# 	}
#     }
# }

##########################################################################
##### max
# Return the largest of two numbers. The load of this procedure checks
# that one doesn't already exist to prevent overwriting the ptklib
# version (which takes multiple arguments).
#
# Note: this version doesn't take multiple arguments: I would prefer
# that the multiple arg version be named say maximum{}, keeping this
# one the way it is for ``speed'' (it is used in some of the critical
# list-iterator functions).
#
# FIXME: Renamed min2 because of autoload problem.
#
proc max2 {x y} {
    if { $x < $y } {
	set y
    } else {
	set x
    }
}

# if { [info commands max] == "" } {
#     proc max {x y} {
# 	if { $x < $y } {
# 	    set y
# 	} else {
# 	    set x
# 	}
#     }
# }

